#include "testlib.h"
#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) (int)(s).size()
#define xx first
#define yy second
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

size_t n;
vector<size_t> g[200500];
bool used[200500];

set<pair<size_t, size_t>> e;

size_t dfs(size_t v) {
    used[v] = true;
    size_t res = 1;
    for (size_t u : g[v]) {
        if (used[u])
            continue;
        res += dfs(u);
    }
    return res;
}

int main(int argc, char* argv[]) {
	//ios::sync_with_stdio(false); cin.tie(0);

	setName("validator");
	registerValidation(argc, argv);

	const size_t MIN_N = 3, MAX_N = 2e5;
	n = inf.readInt(MIN_N, MAX_N, "n");
	inf.readEoln();

	for (size_t i = 0; i < n - 1; i++) {
		size_t u = inf.readInt(1, n, "u_" + i) - 1;
		inf.readSpace();
		size_t v = inf.readInt(1, n, "v_" + i) - 1;
		inf.readEoln();
		
		if (u == v)
		    quitf(_fail, "loops (%d-th edge: %d %d) are forbidden", i + 1, u + 1, v + 1);
		    
		if (e.count({u, v}))
		    quitf(_fail, "multiple edges (%d-th edge: %d %d) are forbidden", i + 1, u + 1, v + 1);
		
		g[u].push_back(v);
		g[v].push_back(u);
		e.insert({u, v});
		e.insert({v, u});
	}
	inf.readEof();
	
	if (dfs(0) != n)
	    quitf(_fail, "graph is not connected");

	return 0;
}
